#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include "vga.h"
#include "mys.h"

typedef float tip;

struct bod {
  tip x, y;
};

struct vektor {
  tip x, y;
};

struct bodvektor {
  tip x, y;
  tip vx, vy;
};

struct uhel {
  tip u;
};

struct gonio {
  tip u, r; // uhel, vzdalenost od stredu;
};

struct objekt {
  bod s; // stred
  tip u; // natoceni
  vektor v; // rychlost
  tip vo; // obvodova rychlost ne polomeru 1 (rotace)
  gonio obvod[500]; // poloha obvodovych bodu objektu
  int poco; // poc obvodovych bodu
};

struct obr {
  int x, y;
};

void smaz(objekt obj[], obr kb[], int poc) {
  int i, j;
  setcolor(0);
  setfillstyle(1,0);
  for (i = 0; i < poc; i++) {
	moveto(kb[i*obj[i].poco].x, kb[i*obj[i].poco].y);
	for (j = 0; j < obj[i].poco; j++) {
//	  putpixel(kb[i*obj[i].poco+j].x, kb[i*obj[i].poco+j].y, 0);
	  lineto(kb[i*obj[i].poco+j].x, kb[i*obj[i].poco+j].y);
	}
	lineto(kb[i*obj[i].poco].x, kb[i*obj[i].poco].y);
//	floodfill(obj[i].s.x, obj[i].s.y, 0);
  }
}

void kopiruj(objekt obj[], obr kb[], int poc) {
  int i, j;
  for (i = 0; i < poc; i++) {
	for (j = 0; j < obj[i].poco; j++) {
	  kb[i*obj[i].poco+j].x = obj[i].s.x + cos(obj[i].u + obj[i].obvod[j].u)*obj[i].obvod[j].r;
	  kb[i*obj[i].poco+j].y = obj[i].s.y + sin(obj[i].u + obj[i].obvod[j].u)*obj[i].obvod[j].r;
	}
  }
}


void kresli(objekt obj[], int poc) {
  int i, j;
  setcolor(15);
  setfillstyle(1,15);
  for (i = 0; i < poc; i++) {
	moveto(obj[i].s.x + cos(obj[i].u + obj[i].obvod[0].u)*obj[i].obvod[0].r, obj[i].s.y + sin(obj[i].u + obj[i].obvod[0].u)*obj[i].obvod[0].r);
	for (j = 0; j < obj[i].poco; j++) {
//	  putpixel(obj[i].s.x + cos(obj[i].u + obj[i].obvod[j].u)*obj[i].obvod[j].r, obj[i].s.y + sin(obj[i].u + obj[i].obvod[j].u)*obj[i].obvod[j].r, 15);
	  lineto(obj[i].s.x + cos(obj[i].u + obj[i].obvod[j].u)*obj[i].obvod[j].r, obj[i].s.y + sin(obj[i].u + obj[i].obvod[j].u)*obj[i].obvod[j].r);
	}
	lineto(obj[i].s.x + cos(obj[i].u + obj[i].obvod[0].u)*obj[i].obvod[0].r, obj[i].s.y + sin(obj[i].u + obj[i].obvod[0].u)*obj[i].obvod[0].r);
//	floodfill(obj[i].s.x, obj[i].s.y, 15);
  }
}

void zrychleni(objekt obj[], int poc) {
  int i;
  for (i = 0; i < poc; i++) {
	obj[i].v.y += 0.01; // gravitace
  }
}

bod draha(bodvektor teleso, unsigned char odraz, tip vzd) {
  tip v, t, tx, ty;
  unsigned char barva = 0;
  bod pom;
  pom.x = 0;
  pom.y = 0;
  v = sqrt(teleso.vx*teleso.vx + teleso.vy*teleso.vy);
  if (v > 0) {
	t = 0;
	while ((t < (v+vzd))&(barva != odraz)) {
	  tx = t/v * teleso.vx;
	  ty = t/v * teleso.vy;
	  barva = getpixel(teleso.x + tx, teleso.y + ty);
	  t += 0.5;
	  ;
	}
  }
  pom.x = teleso.x + tx;
  pom.y = teleso.y + ty;
  return(pom);
}

vektor odrzvekt(bod c, vektor w, vektor v) {
  tip n, k;
  bod b;
  vektor pom;
  n = (v.x*w.y - v.y*w.x)/(w.x*w.x + w.y*w.y);
  k = (-v.x + n*w.y)/w.x;
  pom.x = + v.x - 2*n*w.y;
  pom.y = - k*w.y + n*w.x;
  return(pom);
}

bodvektor odraz(bodvektor bv) {
  bodvektor b1, b2;
  bod a, b, c;
  vektor w, u, t;
  tip v;
  v = sqrt(bv.vx*bv.vx + bv.vy*bv.vy);
  if (v > 0) {
		b1.x = bv.x - bv.vy/v*2 - bv.vx*5;
		b1.y = bv.y + bv.vx/v*2 - bv.vy*5;
		b1.vx = bv.vx;
		b1.vy = bv.vy;
		b2.x = bv.x + bv.vy/v*2 - bv.vx*5;
		b2.y = bv.y - bv.vx/v*2 - bv.vy*5;
		b2.vx = bv.vx;
		b2.vy = bv.vy;
		a = draha(b1,14,20);
		b = draha(b2,14,20);
//		putpixel(a.x, a.y, 12);
//		putpixel(b.x, b.y, 12);
		w.x = a.x - b.x;
		w.y = a.y - b.y;
		t.x = bv.vx;
		t.y = bv.vy;
		c.x = bv.x;
		c.y = bv.y;
		u = odrzvekt(c, w, t);
		bv.vx = u.x;
		bv.vy = u.y;
		bv.vx *= 0.6;
		bv.vy *= 0.6;
  }
  return(bv);
}

void rozklad(bodvektor o, objekt *obj, tip r) {
  vektor v, w, n;
  tip k, l, vo;
  o.x += o.vx;
  o.y += o.vy;
  w.x = (*obj).s.x - o.x;
  w.y = (*obj).s.y - o.y;
  v.x = o.vx;
  v.y = o.vy;
  n.x = -w.y;
  n.y = w.x;
  l = (v.x*w.y - v.y*w.x)/(w.y*w.y + w.x*w.x);
//  k = (l*w.y - v.x)/w.x;
//  k = (-v.x*w.y - v.y*w.x)/(w.y*w.y + w.x*w.x);
  n.x = n.x*l;
  n.y = n.y*l;
  vo = sqrt(n.x*n.x + n.y*n.y)/r;
  (*obj).vo = sqrt(n.x*n.x + n.y*n.y)/r;
  if (o.x < (*obj).s.x)
	if (n.y > 0 ) (*obj).vo *= -1;
  if (o.x > (*obj).s.x)
	if (n.y < 0 ) (*obj).vo *= -1;
  vo *= 0.5;
  (*obj).vo += vo;
  (*obj).vo *= 0.8;
//  (*obj).v.x = w.x*k;
//  (*obj).v.y = w.y*k;
  (*obj).v.x = o.vx;
  (*obj).v.y = o.vy;
}

void prostredi(objekt obj[], int poc) {
  int i, j;
  bodvektor obv; // obvodovy bod
  bodvektor odr; // odrazovy vektor
  bod sn; // souradnice narazu
  for (i = 0; i < poc; i++) {
	for (j = 0; j < obj[i].poco; j++) {
	  obv.x = obj[i].s.x + cos(obj[i].u + obj[i].obvod[j].u)*obj[i].obvod[j].r;
	  obv.y = obj[i].s.y + sin(obj[i].u + obj[i].obvod[j].u)*obj[i].obvod[j].r;
	  obv.vx = obj[i].v.x + sin(obj[i].u - obj[i].obvod[j].u)*obj[i].vo*obj[i].obvod[j].r*0.5;
	  obv.vy = obj[i].v.y + cos(obj[i].u - obj[i].obvod[j].u)*obj[i].vo*obj[i].obvod[j].r*0.5;
//	  obv.vx = obj[i].v.x;
//	  obv.vy = obj[i].v.y;
//	  obv.x = obj[i].s.x;
//	  obv.y = obj[i].s.y;
	  sn = draha(obv, 14, 0.5);
	  if (getpixel(sn.x, sn.y) == 14) {
		odr = odraz(obv);
		rozklad(odr, &obj[i], obj[i].obvod[j].r);
//		obj[i].v.x = odr.vx;
//		obj[i].v.y = odr.vy;
	  }
	}
  }
}


void posun(objekt obj[], int poc) {
  int i;
  for (i = 0; i < poc; i++) {
	obj[i].s.x += obj[i].v.x;
	obj[i].s.y += obj[i].v.y;
	obj[i].u += asin(obj[i].vo);
  }
}

void omez(objekt obj[], int poc) {
  int i;
  for (i = 0; i < poc; i++) {
	if (obj[i].v.x > 5) obj[i].v.x = 5;
	if (obj[i].v.y > 5) obj[i].v.y = 5;
	if (obj[i].vo > 1) obj[i].vo = 1;
	if (obj[i].v.x < -5) obj[i].v.x = -5;
	if (obj[i].v.y < -5) obj[i].v.y = -5;
	if (obj[i].vo < -1) obj[i].vo = -1;
  }
}


void prepocti(objekt obj[], int poc) {
  zrychleni(obj, poc);
  prostredi(obj, poc);
  omez(obj, poc);
  posun(obj, poc);
}

void wrddef() {
  tip x, y;
  setcolor(14);
  randomize();

  for(x = 0; x < getmaxx(); x += 0.1) {
//	  y = sin(x*0.01)*sin(x*0.2)*20+cos(x*0.1)*x*0.1+sin(x*0.01-1)*50+100+b*10;
//	  y = cos(x*0.005-2)*150+sin(x*0.1)*x*0.01+100+b*0.5;
	y = pow(2 , sin(x*0.05)*5)+sin(x*0.03)*x*0.1+200;
	putpixel(x, y, 14);
  }
//  line(0, 250, 640, 250);
  setfillstyle(1,14);
  floodfill(0,300,14);
}
void objdef(objekt obj[], int poc) {
  setcolor(15);
  int u, i, k = 20;
  setfillstyle(1,15);
  for (i = 0; i < poc; i ++) {
	putpixel(100 + i*k*2, 100, 12);
	line(100-k + i*k*2, 100-k, 100+k + i*k*2, 100-k);
	line(100+k + i*k*2, 100-k, 100+k + i*k*2, 100+k);
	line(100+k + i*k*2, 100+k, 100-k + i*k*2, 100+k);
	line(100-k + i*k*2, 100+k, 100-k + i*k*2, 100-k);
  }
  mouse mys;
  while (!kbhit()) {
	mys.aktual();
	if (mys.get_left()) {
	  mys.set_off();
	  putpixel(mys.get_x(), mys.get_y(), 15);
	  mys.set_on();
	}
	if (mys.get_right()) {
	  mys.set_off();
	  floodfill(mys.get_x(), mys.get_y(), 15);
	  mys.set_on();
	}
  }
  for (i = 0; i < poc; i ++) {
	obj[i].s.x = 200+i*k*2;
	obj[i].s.y = 100;
	obj[i].v.x = i*0.2;
	obj[i].v.y = 0;
	obj[i].u = 0;
	obj[i].vo = i*0.05;
	obj[i].poco = 50;
  }
  unsigned char c;
  tip vzd = 0, krok, x, y;
  for(i = 0; i < poc; i ++) {
	for(u = 0; u < obj[i].poco; u ++) {
	  vzd = 0;
	  c = 0;
	  krok = 2*M_PI/obj[i].poco;
	  while ((c != 15)&(vzd < k*2)) {
		x = 100 + i*k*2 + cos(u*krok)*vzd;
		y = 100 + sin(u*krok)*vzd;
		c = getpixel(x, y);
		vzd += 0.1;
	  }
	  obj[i].obvod[u].u = u*krok;
	  obj[i].obvod[u].r = vzd;
	}
  }
  cleardevice();
}

const poc = 6;
objekt obj[6];
obr bd[5000];

void main(void) {
  initvga(1);
  objdef(obj, poc);

  wrddef();
  swapactivep();
  wrddef();

  getch();
  while (!kbhit()) {
	swapactivep();
	smaz(obj, bd, poc);
	kopiruj(obj, bd, poc);
	prepocti(obj, poc);
	kresli(obj, poc);
	delay(1);
	swapvisualp();
	delay(1);
  }
  closegraph();
}